program EmailCmd;

uses
  SysUtils, Winsock;

var
 localhostname, tmpstr: array [0..255] of char;
 ws: TWSADATA; s: Tsocket; si: Tsockaddr; hostdata: PHostent; localhost: PHostent;
 tmpstr2: string;
 i: byte;

procedure append_and_send(content: string);
var buf: array [0..255] of char;
begin
  StrPCopy(buf, content+#13+#10);
  if ( send(s,buf,strlen(buf),0) = SOCKET_ERROR ) then
   begin writeln('Client Error: failed in the middle of sending data!'); halt end;
end;

begin
  if paramcount<2 then begin
    writeln;
    writeln('Freeware commandline utility - by Lai KamLeong');
    writeln;
    writeln('EMAILCMD me@here.com smtp.server 2some1@somewhere.com subject [/d]');
    writeln('  [msg_ln1 [msg_ln2 [..]]]');
    writeln;
    writeln('  /d   Get message from console (enter a blank line to end)');
    writeln('       or use redirected input from a text file (i.e. followed by [< file.txt])');
    writeln;
    exit;
   end;

  if ( WSAStartup($0101,ws) <> 0 ) then  begin writeln('Client Error: WSAStartup() failed !'); exit end;
  if ( gethostname(localhostname,40) = 0 ) then  localhost:=gethostbyname(localhostname);

  s:=socket(PF_INET,SOCK_STREAM,0);
  if (s=INVALID_SOCKET) then  begin writeln('Client Error: socket() failed !'); exit end;

  si.sin_family := AF_INET;  si.sin_port := htons(25);
  si.sin_addr.s_addr := inet_addr(StrPCopy(tmpstr,ParamStr(2)));
  if (si.sin_addr.s_addr=INADDR_NONE) then
   begin
    hostdata:=gethostbyname(tmpstr);
    if ( hostdata<>nil ) then
      si.sin_addr := PInAddr(hostdata.h_addr_list^)^
    else begin writeln('Unable to resolve host name! <',ParamStr(2), '>'); exit end;
   end;

  if ( connect(s,si,sizeof(si)) = SOCKET_ERROR ) then
   case WSAGetLastError() of
    WSAEINPROGRESS : ; WSAEWOULDBLOCK : ;//still connecting ...
    WSAEISCONN : writeln('already connected!')
    else begin writeln('Client Error: connect() failed !'); exit end;
   end;

  recv(s,tmpstr,255,0);  //write('r: ',strpas(tmpstr));

  append_and_send('HELO ' + localhostname);
  recv(s,tmpstr,255,0);  //write('r: ',strpas(tmpstr));

  append_and_send('MAIL FROM:<' + ParamStr(1) + '>');
  recv(s,tmpstr,255,0);  //write('r: ',strpas(tmpstr));

  append_and_send('RCPT TO:<' + ParamStr(3) + '>');
  recv(s,tmpstr,255,0);  //write('r: ',strpas(tmpstr));

  append_and_send('DATA');
  recv(s,tmpstr,255,0);  //write('r: ',strpas(tmpstr));

  append_and_send('Subject: ' + ParamStr(4));
  append_and_send(#13+#10); //header ends here

  for i:=5 to ParamCount do
  begin
   if (ParamStr(i)='/d') or (ParamStr(i)='/D') then
    repeat readln(tmpstr2); append_and_send(tmpstr2) until tmpstr2=''
   else
    append_and_send(ParamStr(i));
  end;

  append_and_send(#13+#10+'.');
  recv(s,tmpstr,255,0);  //write('r: ',strpas(tmpstr));

  append_and_send('QUIT');
  recv(s,tmpstr,255,0);  //write('r: ',strpas(tmpstr));

  closesocket(s); WSACleanup;
  writeln('Done!');
end.
